/*****************************************************************************
 *                            CNetC library examples                         *
 *                         copyright  ZenMetal Software                     *
 *                              All rights reserved.                         *
 *                                                                           *
 *                 Special thanks to Kelly Cochran for his initial           *
 *                 conversion of empty.c code to a shared library.           *
 *****************************************************************************/

/* --------------------- GLOBAL VARIABLE/DATA SECTION ---------------------- */

struct Library         *CNetCBase    = NULL; // pointer to cnet.library lib base
struct CNetCContext    *context      = NULL; // pointer to context data, containing
                                             // cnet mainport, current portdata, etc,.
                                             // see include/doors.h for
                                             // structure information
struct PortData        *z            = NULL; // pointer to be initialized later to
                                             // context->z
struct MainPort        *myp          = NULL; // pointer to be initialized later to
                                             // context->myp

/* --------------------- BEGINNING OF DOOR FUNCTIONS ----------------------- */

void GetOut(void)
{
   /* ------------- YOUR CLEANUP CODE STARTS HERE - IF ANY ----------------- */







   /* -------------- CNETC DOOR SHUTDOWN PROCEDURE BEGINS ------------------ */
   if(context)
      {
      CNC_ShutDown(NULL);
      CNC_DisposeContext();
      context=NULL;
      }
   if(CNetCBase)
      {
      CloseLibrary(CNetCBase);
      CNetCBase=NULL;
      }
}



void main(int argc, char **argv)
{
   /* ------------------ CHECK IF RAN AS A CNETC DOOR ---------------------- */
   if(argc < 2)
      {
      Printf("This is a CNetC Program!\n");
      return;
      }
   /* ------------------ CNETC DOOR SETUP STARTS HERE ---------------------- */
   atexit(GetOut); // an exit trap so that GetOut() is invoked when exit() is called.
   if( !(CNetCBase = OpenLibrary("cnetc.library", 4)) )
      GetOut();
   if( !(context = CNC_InitContext(argv[1])) )
      GetOut();

   z		=	context->z;
   myp	=	context->myp;
   /* --------------------- YOUR CODE BEGINS HERE -------------------------- */









   /* --------------------- END OF YOUR MAIN CODE -------------------------- */
   exit(0); // exit back to CNet - exit trap automatically calls GetOut()
}

