/*****************************************************************************
 *                            CNetC library examples                         *
 *                         copyright  ZenMetal Software                     *
 *                              All rights reserved.                         *
 *                                                                           *
 *                 Special thanks to Kelly Cochran for his initial           *
 *                 conversion of empty.c code to a shared library.           *
 *****************************************************************************/


/*
 * NOTE: THIS CODE IS 3RD PARTY SOURCE, DISTRIBUTED BY WITH CNET AS EXAMPLE
 *       CODE.  ZENMETAL ASSUMES NO RESPONSIBILITY FOR ITS FUNCTIONALITY
 *       OR NON-FUNCTIONALITY.
 *
 /

/* --------------------- GLOBAL VARIABLE/DATA SECTION ---------------------- */

struct Library         *CNetCBase    = NULL; // pointer to cnet.library lib base
struct CNetCContext    *context      = NULL; // pointer to context data, containing
                                             // cnet mainport, current portdata, etc,.
                                             // see include/doors.h for
                                             // structure information
struct PortData        *z            = NULL; // pointer to be initialized later to
                                             // context->z
struct MainPort        *myp          = NULL; // pointer to be initialized later to
                                             // context->myp

/* --------------------- BEGINNING OF DOOR FUNCTIONS ----------------------- */

void GetOut(void)
{
   /* ------------- YOUR CLEANUP CODE STARTS HERE - IF ANY ----------------- */







   /* -------------- CNETC DOOR SHUTDOWN PROCEDURE BEGINS ------------------ */
   if(context)
      {
      CNC_ShutDown(NULL);
      CNC_DisposeContext();
      context=NULL;
      }
   if(CNetCBase)
      {
      CloseLibrary(CNetCBase);
      CNetCBase=NULL;
      }
}



void main(int argc, char **argv)
{
	int  count = 0;
	char   key;
	BOOL  DONE = FALSE;

   /* ------------------ CHECK IF RAN AS A CNETC DOOR ---------------------- */
   if(argc < 2)
      {
      Printf("This is a CNetC Program!\n");
      return;
      }
   /* ------------------ CNETC DOOR SETUP STARTS HERE ---------------------- */
   atexit(GetOut); // an exit trap so that GetOut() is invoked when exit() is called.
   if( !(CNetCBase = OpenLibrary("cnetc.library", 4)) )
      GetOut();
   if( !(context = CNC_InitContext(argv[1])) )
      GetOut();

   z		=	context->z;
   myp	=	context->myp;
   /* --------------------- YOUR CODE BEGINS HERE -------------------------- */


	z->user1.ANSI = 2;

	if ( z->LocalMode )
		{
		CNC_PutText("n1Local Terminal");
		z->KBuff[ z->KB1 ] = 105;
		z->KB2++;
		}
	else
		{
		CNC_PutText("[6n");
		z->KB2 = z->KB1;
		CNC_PutText("n1Auto-detecting ANSI (SPACE=ABORT).");

		while( !DONE )
			{
			key = CNC_WaitForInput( 200000 );
			if( key != 27 && key != 82 && key != 114 && key >= 1 )
				count--;

			if( count == 12 )
				DONE = TRUE;

			CNC_PutText(".");

			if( key == 32 )
				{
				CNC_PutText("*** ABORT ***");
				DONE = TRUE;
				}

			if( key == 82 || key == 114 )
				{
				CNC_PutText("n1--> ANSI Found!");
				z->KB2 = z->KB1;
				z->KBuff[ z->KB1 ] = 105;
				z->KB2++;
				GetOut();
				}
			count++;
			}     

		CNC_PutText("n1--> Could not detect ANSI...n2");

		z->user1.ANSI = 0;
		CNC_PutText("Terminal (A)nsi, [NONE]:");
		z->KB2 = z->KB1;
		}


   /* --------------------- END OF YOUR MAIN CODE -------------------------- */
   exit(0); // exit back to CNet - exit trap automatically calls GetOut()
}

