// CNet Amiga/4 Programming examples
// copyright  1998 Ray A. Akey
// Exclusive license granted to ZenMetal Software and CNet door coders.

/************************************************************************
 *                          Function prototypes                         *
 ************************************************************************/
void DisplayIdentD( void );


/************************************************************************
 *                           Global Variables                           *
 ************************************************************************/
struct CNetCContext    *context  = NULL;
struct MainPort        *myp;
struct PortData        *z;
char	                 **bm;
struct Library         *CNetCBase = NULL;
struct Library         *CNetBase  = NULL;
struct Library         *CNet4Base = NULL;
struct SignalSemaphore *SEM;


int intGetOut( void )
{
	exit(0);
	return 0;
}


void GetOut(void)
{
   /* ------------- YOUR CLEANUP CODE STARTS HERE - IF ANY ----------------- */


   /* -------------- CNETC DOOR SHUTDOWN PROCEDURE BEGINS ------------------ */
   if(context)
      {
      CNC_ShutDown(NULL);
      CNC_DisposeContext();
      context=NULL;
      }
   if(CNetCBase)
      {
      CloseLibrary(CNetCBase);
      CNetCBase=NULL;
      }
   if(CNetBase)
      {
      CloseLibrary(CNetBase);
      CNetBase=NULL;
      }
   if(CNet4Base)
      {
      CloseLibrary(CNet4Base);
      CNet4Base=NULL;
      }
}

/************************************************************************
 *                             Main routine                             *
 ************************************************************************/
void main( int argc, char **argv )
{
	int x=0;

	// ---------------------- CHECK IF RAN AS A CNETC DOOR ---------------------
   if(argc < 2)
   	{
      Printf("This is a CNetC Program!\n");
      return;
   	}
   	
   // ----------------------- CNETC DOOR SETUP STARTS HERE --------------------
	atexit(GetOut);
	onbreak(intGetOut); // this break trap causes the program to exit when
   if( !(CNetCBase = OpenLibrary("cnetc.library", 4)) ) // library required for ALL CNetC doors.
   	GetOut();
   if( !(CNet4Base = OpenLibrary("cnet4.library", 4)) ) // library required for CalculateAge() and other date-related routines
   	GetOut();
	if( !(CNetBase = OpenLibrary( "cnet.library", 4 )) ) // <- NOTE lib version 4 - can be changed to 3 to make compatible with older CNet releases!
		GetOut();
   if( !(context = CNC_InitContext(argv[1])) )
   	GetOut();

	z=context->z;
   myp=context->myp;
	SEM  = myp->SEM;
	bm   = z->bm;


	// -------------------------- YOUR CODE BEGINS HERE ------------------------

/************************************************************************
 *           End of CNet setup - YOUR CUSTOM CODE STARTS HERE           *
 ************************************************************************/

	DisplayIdentD();

/************************************************************************
 *                         exit back to CNet!
 ************************************************************************/

	// note that an exit trap calling GetOut() has been inserted previously to
	// facilitate resource cleanup..
	exit(0);
}



void DisplayIdentD( void )
{
	if(myp->MPE->idd)
		{
		struct IdentdData *iddptr=myp->MPE->idd;
		// walk the list of identd data and print specifics
		while(iddptr)
			{
			sprintf(z->ABuffer, "Socket number: %ld, CNet Owner Port: %ld\n", iddptr->socket, iddptr->port);
			CNC_PutA();
			iddptr=iddptr->next;
			}
		}
	else
		{
		CNC_PutText("No identd entries\n");
		}
}
