// CNet Amiga/4 Programming examples
// copyright  1998 Ray A. Akey
// Exclusive license granted to ZenMetal Software and CNet door coders.

/* --------------------- GLOBAL VARIABLE/DATA SECTION ---------------------- */

struct Library         *CNetCBase    = NULL; // pointer to cnet.library lib base
struct Library         *CNet4Base    = NULL; // pointer to cnet4.library lib base
struct CNetCContext    *context      = NULL; // pointer to context data, containing
                                             // cnet mainport, current portdata, etc,.
                                             // see include/doors.h for
                                             // structure information
struct PortData        *z            = NULL; // pointer to be initialized later to
                                             // context->z
struct MainPort        *myp          = NULL; // pointer to be initialized later to
                                             // context->myp

/* --------------------- BEGINNING OF DOOR FUNCTIONS ----------------------- */

void GetOut(void)
{
   /* ------------- YOUR CLEANUP CODE STARTS HERE - IF ANY ----------------- */



   /* -------------- CNETC DOOR SHUTDOWN PROCEDURE BEGINS ------------------ */
   if(context)
      {
      CNC_ShutDown(NULL);
      CNC_DisposeContext();
      context=NULL;
      }
   if(CNetCBase)
      {
      CloseLibrary(CNetCBase);
      CNetCBase=NULL;
      }
   if(CNet4Base)
      {
      CloseLibrary(CNet4Base);
      CNet4Base=NULL;
      }
}



void main(int argc, char **argv)
{
	struct RangeContext rc;
	LONG x;

   /* ------------------ CHECK IF RAN AS A CNETC DOOR ---------------------- */
   if(argc < 2)
      {
      Printf("This is a CNetC Program!\n");
      return;
      }
   /* ------------------ CNETC DOOR SETUP STARTS HERE ---------------------- */
   atexit(GetOut); // an exit trap so that GetOut() is invoked when exit() is called.
   if( !(CNetCBase = OpenLibrary("cnetc.library", 4)) )
      GetOut();
   if( !(CNet4Base = OpenLibrary("cnet4.library", 4)) )
      GetOut();
   if( !(context = CNC_InitContext(argv[1])) )
      GetOut();

   z		=	context->z;
   myp	=	context->myp;
   /* --------------------- YOUR CODE BEGINS HERE -------------------------- */

	while(CNC_EnterLine(40, ELINE_INPUTBOX, "Enter a CNet range: "))
		{
		if(CNetFindRange(z->InBuffer, 1, 100, &rc))
			{
			for(;;)
				{
				x=CNetNextRange(&rc);
				sprintf(z->ABuffer, "value: %4.4ld    nparts: %2ld    set: %2ld    element: %4ld\n", x, rc.nparts, rc.set, rc.element);
				CNC_PutA();
				if( (rc.set == (rc.nparts-1)) && (rc.element == (rc.parts[rc.set][1])) )
					{
					CNC_PutText("END OF RANGE!\n");
					exit(0);
					}
				}
			}
		}

   /* --------------------- END OF YOUR MAIN CODE -------------------------- */
   exit(0); // exit back to CNet - exit trap automatically calls GetOut()
}

