/*******************************************************
 * $VER: MD2Yam.rexx V1.0 (24-Feb-98) by Mark Yovorsky *
 *                                                     *
 * Convert Microdot-II bookmarks to YAM V2.0 format    *
 *                                                     *
 *   www.interlog.com/~vista / vista@interlog.com      *
 *******************************************************/

OPTIONS RESULTS
parse arg mdpath yampath

/* Check files */
IF ~EXISTS(mdpath) then do
    SAY "Can't find" mdpath
    exit
end

IF ~EXISTS(yampath) then do
    SAY "Can't find" yampath
    exit
end

IF ~OPEN('MD',MDPath,'R') THEN DO
    SAY "Can't open" mdpath
    EXIT
END

IF ~OPEN('Yam',YAMPath,'A') THEN DO
    SAY "Can't open" yampath
    EXIT
END


/* Read source file */
CALL READLN('MD') /* Header */

DO UNTIL EOF('MD')
    Line=READLN('MD')
    SELECT
	WHEN LEFT(Line,1)="" THEN DO   /* Group */
	    CALL WRITELN('Yam','@GROUP' RIGHT(Line,LENGTH(Line)-1))
	    CALL WRITELN('Yam','')
	END

	WHEN LEFT(Line,1)="" THEN      /* End Group */
	    CALL WRITELN('Yam','@ENDGROUP')

	OTHERWISE DO                    /* User */
	    PARSE VAR Line Name'|'address

	    CALL WRITELN('Yam','@USER')
	    CALL WRITELN('Yam',address)
	    CALL WRITELN('Yam',name)
	    CALL WRITELN('Yam','')
	    CALL WRITELN('Yam','')
	    CALL WRITELN('Yam','')
	    CALL WRITELN('Yam','')
	    CALL WRITELN('Yam','')
	    CALL WRITELN('Yam','00000000')
	    CALL WRITELN('Yam','')
	    CALL WRITELN('Yam','')
	    CALL WRITELN('Yam','')
	    CALL WRITELN('Yam','@ENDUSER')
	END
    END
END

SAY "Finished converting file. Enjoy :)"
